package org.steveshipway.cheshirecat;

import java.util.EnumMap;

import org.steveshipway.blueprints.AutoGenerator;
import org.steveshipway.cheshirecat.cmd.*;

import net.minecraftforge.common.config.Configuration;

// Minecraft 1.7
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.event.FMLServerStartingEvent;
import cpw.mods.fml.common.eventhandler.SubscribeEvent;
import cpw.mods.fml.common.gameevent.PlayerEvent.PlayerLoggedInEvent;
import cpw.mods.fml.common.network.FMLEmbeddedChannel;
import cpw.mods.fml.common.network.FMLOutboundHandler;
import cpw.mods.fml.common.network.NetworkRegistry;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.relauncher.Side;
// Minecraft 1.8
//import net.minecraftforge.fml.common.FMLCommonHandler;
//import net.minecraftforge.fml.common.event.FMLInitializationEvent;
//import net.minecraftforge.fml.common.event.FMLPostInitializationEvent;
//import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
//import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
//import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
//import net.minecraftforge.fml.common.gameevent.PlayerEvent.PlayerLoggedInEvent;
//import net.minecraftforge.fml.common.network.FMLEmbeddedChannel;
//import net.minecraftforge.fml.common.network.FMLOutboundHandler;
//import net.minecraftforge.fml.common.network.NetworkRegistry;
//import net.minecraftforge.fml.common.registry.GameRegistry;
//import net.minecraftforge.fml.relauncher.Side;

public class CommonProxy
{
    public void preInit(FMLPreInitializationEvent e) {
    	
    	// define custom blocks
    	CCBlocks.preinit();
    	// define custom items
    	CCItems.preinit();

    }

    public void init(FMLInitializationEvent e) {
    	// set up recipies
    	CCRecipies.init();
		if(e.getSide() == Side.CLIENT)
		{
				CCItems.init();
				CCBlocks.init();
//		} else {
		}
		if( CheshireCat.enableAutoGen ) { 
			CheshireCat.autoGen = new AutoGenerator(CheshireCat.portfolio, CheshireCat.logger);
    		GameRegistry.registerWorldGenerator(CheshireCat.autoGen, 100); // heavy weight; we want to run late
    		CheshireCat.logger.info("Added Blueprint autogeneration module to the world");
		}
    }

    public void postInit(FMLPostInitializationEvent e) {

    }
    
    public void serverLoad(FMLServerStartingEvent event)
    {
      event.registerServerCommand(new BuildCommand());
      event.registerServerCommand(new BlueprintsCommand());
      event.registerServerCommand(new WandCommand());
    }
    
    public void registerRenderers() {
        // Nothing here as the server doesn't render graphics or entities!
    }
}
